// $Id: KappaLayoutTest.java,v 2.4 2001/06/04 04:20:41 danson Exp $

package examples;

import ise.java.awt.*;
import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;

public class KappaLayoutTest extends Applet {

   public void init() {
      // set up a Frame
      final Frame f = new Frame("KappaLayout Test");
      f.addWindowListener(new WindowAdapter() {
                             public void windowClosing(WindowEvent we) {
                                f.dispose();
                             }
                          });

      Panel content_panel = new Panel() {
         public Insets getInsets() {
            return new Insets(10, 10, 10, 10);
         }
      };
      content_panel.setLayout(new KappaLayout());


      // standard use of KappaLayout
      KappaLayout kl2 = new KappaLayout();
      Panel p1 = new Panel(kl2);
      Label label = new Label("Enter name of file to copy:");
      p1.add(label, "0,0,r,1,W,,3");
      TextField field = new TextField(50);
      p1.add(field, "0,1,1,1,,wh,3");
      Button button = new Button("Browse...");
      p1.add(button, "1,1,1,1,,w,3");

      // use KappaLayout.Constraints, this makes a panel identical to panel p1
      Panel p2 = new Panel(new KappaLayout());
      KappaLayout.Constraints con = KappaLayout.createConstraint();
      con.x = 0;
      con.y = 0;
      con.w = 2;
      con.h = 1;
      con.a = KappaLayout.W;
      con.p = 3;
      p2.add(new Label("Enter name for copy of file:"), con);
      con.y += 1;
      con.w = 1;
      con.a = 0;
      p2.add(new TextField(50), con);
      con.x += 1;
      con.s = "w";
      p2.add(new Button("Browse..."), con);

      // make a button panel -- make the buttons the same width by
      // stretching to fill cells horizontally and setting the columns to the
      // same width
      KappaLayout kl3 = new KappaLayout();
      Panel p3 = new Panel(kl3);
      p3.add(new Button("Start Copy"), "0,0,1,1,,w");
      p3.add(new Button("Cancel"), "1,0,1,1,,w");
      kl3.makeColumnsSameWidth(0, 1);

      // lay out the frame, using a couple of vertical struts to unclutter the parts
      content_panel.add(p1, "0,0,1,1");
      content_panel.add(KappaLayout.createVerticalStrut(11), "0,1,1,1");
      content_panel.add(p2, "0,2,1,1");
      content_panel.add(KappaLayout.createVerticalStrut(11), "0,3,1,1");
      content_panel.add(p3, "0,4,1,1");
      f.add(content_panel);
      f.pack();
      f.show();
      System.out.println(kl2);
   }

   public static void main(String[] args) {
      KappaLayoutTest klt = new KappaLayoutTest();
      klt.init();
   }
}
