// $Id: KappaLayoutTest3.java,v 2.3 2001/06/02 14:04:59 danson Exp $

package examples;

import ise.java.awt.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;

/**
 * Another example of KappaLayout showing a dialog that has always been
 * difficult to do nicely -- getting the buttons to center on the lists vertically
 * is a hassle and getting the lists to be the same width and height is similarly
 * difficult. Perhaps most difficult is centering the bottom buttons. KappaLayout
 * makes this easy.
 */
public class KappaLayoutTest3 {

   public KappaLayoutTest3() {
      // set up a Frame
      final Frame f = new Frame("KappaLayout Test 3");
      f.addWindowListener(new WindowAdapter() {
                             public void windowClosing(WindowEvent we) {
                                f.dispose();
                             }
                          });
      LambdaLayout ll = new LambdaLayout();
      Panel p = new Panel(){
         public Insets getInsets() {
            return new Insets(10, 10, 10, 10);
         }
         };
      p.setLayout(ll);

      /*
      Design:
       012
      0L L     L = Labels
      1C C     C = List, span 6 rows
      2C C
      3CBC     B = Button, ->
      4CBC     B = Button, <-
      5C C
      6C C
      7PPP     P = Panel w/Buttons, span 3 columns
      */
      p.add("0,0,,1,7,w,2", new Label("Pick something from this list:"));
      p.add("2,0,,1,7,w,2", new Label("Selected items:"));
      p.add("0,1,,6,,wh,5", new java.awt.List(10));
      p.add("2,1,,6,,wh,5", new java.awt.List(10));
      p.add("1,3", new Button("->"));
      p.add("1,4", new Button("<-"));
      ll.makeColumnsSameWidth(0,2);

      KappaLayout kl = new KappaLayout();
      Panel button_panel = new Panel();
      button_panel.setLayout(kl);
      button_panel.add("0,0,,,,w", new Button("OK"));
      button_panel.add("1,0,,,,w", new Button("Cancel"));
      kl.makeColumnsSameWidth(0,1);
      p.add("0,7,3,1", button_panel);

      f.add(p);
      f.pack();                             
      f.show();
      //System.out.println(ll.toString());
      //System.out.println(kl.toString());
   }

   public static void main(String[] args) {
      new KappaLayoutTest3();
   }
}

