// $Id: KappaLayoutTestSwing.java,v 2.2 2001/06/02 14:04:59 danson Exp $

package examples;

import ise.java.awt.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;

public class KappaLayoutTestSwing extends Applet {

   public KappaLayoutTestSwing() {
      // set up a Frame
      final JFrame f = new JFrame("KappaLayout Test with Swing");
      f.addWindowListener(new WindowAdapter() {
                             public void windowClosing(WindowEvent we) {
                                f.dispose();
                             }
                          });
      JPanel contents = new JPanel(new KappaLayout());
      f.setContentPane(contents);

      // standard use of KappaLayout
      JPanel p1 = new JPanel(new KappaLayout());
      p1.add("0,0,1,1,7,,3", new JLabel("Enter name of file to copy:"));
      p1.add("0,1,1,1,,,3", new JTextField(30));
      p1.add("1,1,1,1,,hw,3", new JButton("Browse..."));

      // use KappaLayout.Constraints, this makes a panel identical to panel p1
      JPanel p2 = new JPanel(new KappaLayout());
      KappaLayout.Constraints con = KappaLayout.createConstraint();
      con.x = 0;
      con.y = 0;
      con.w = 1;
      con.h = 1;
      con.a = 7;
      con.p = 3;
      p2.add(new JLabel("Enter name for copy of file:"), con);
      con.y += 1;
      con.a = 0;
      p2.add(new JTextField(30), con);
      con.x += 1;
      con.s = "wh";
      p2.add(new JButton("Browse..."), con);

      KappaLayout kl3 = new KappaLayout();
      JPanel p3 = new JPanel(kl3);
      p3.add("0,0,1,1,,w", new JButton("Start Copy"));
      p3.add("1,0", KappaLayout.createHorizontalStrut(5, true));
      p3.add("2,0,1,1,,w", new JButton("Cancel"));
      kl3.makeColumnsSameWidth(0,2);

      // lay out the frame, using a couple of vertical struts to unclutter the parts
      contents.setBorder(new EmptyBorder(12, 11, 11, 12));
      contents.add("0,0,1,1", p1);
      contents.add("0,1,1,1", KappaLayout.createVerticalStrut(17));
      contents.add("0,2,1,1", p2);
      contents.add("0,3,1,1", KappaLayout.createVerticalStrut(17));
      contents.add("0,4,1,1", p3);
      f.pack();
      f.show();
   }

   public static void main(String[] args) {
      new KappaLayoutTestSwing().init();
   }
}

