// $Id: MiscDialog.java,v 1.2 2001/03/22 20:54:59 danson Exp $

package examples;

import java.awt.*;
import java.awt.event.*;
import java.text.*;
import java.util.*;
import ise.java.awt.*;

public class MiscDialog extends Dialog {

   private Button btn;
   private String _misc_btn_txt = "<Itemize>";
   private Label total_field;
   private TextField[] items = new TextField[7];
   private TextField[] amounts = new TextField[7];
   private TextField[] comments = new TextField[7];
   private Choice[] accts = new Choice[7];
   private String pad = "               ";
   private Frame _parent;

   public MiscDialog(Frame f, Vector acct_list) {
      super(f, "Miscellaneous Expense Detail", true);
      //setResizable(false);
      _parent = f;
      KappaLayout kl0 = new KappaLayout();
      this.setLayout(kl0);

      Label dl = new Label("Item", Label.CENTER);
      dl.setBackground(Color.cyan.darker());
      this.add(dl, "0,0,1,1,,wh,1");
      dl = new Label("Comment", Label.CENTER);
      dl.setBackground(Color.cyan.darker());
      this.add(dl, "1,0,1,1,,wh,1");
      dl = new Label("Amount", Label.CENTER);
      dl.setBackground(Color.cyan.darker());
      this.add(dl, "2,0,1,1,,wh,1");

      KappaLayout.Constraints q = KappaLayout.createConstraint();
      q.s = "w";
      int top_row = 1;
      for ( int y = top_row; y < top_row + 7; y++ ) {
         q.x = 0;
         q.y = y;
         TextField item = new TextField(25);
         items[y - top_row] = item;
         add(item, q);
         ++ q.x;
         TextField comment = new TextField(15);
         comments[y - top_row] = comment;
         add(comment, q);
         ++ q.x;
         TextField amount = new TextField(15);
         amounts[y - top_row] = amount;
         add(amount, q);
         ++ q.x;
         Choice acct = new Choice();
         accts[y - top_row] = acct;
         if ( acct_list != null ) {
            Enumeration enum = acct_list.elements();
            while ( enum.hasMoreElements() )
               acct.addItem(enum.nextElement().toString());
            //add(acct, q);
         }
      }
      ++ q.y;
      q.x = 1;
      q.a = KappaLayout.E;
      Label total_label = new Label("Total:", Label.RIGHT);
      total_label.setBackground(Color.cyan.darker());
      this.add(total_label, q);
      ++ q.x;
      q.s = "wh";
      total_field = new Label(pad, Label.RIGHT);
      total_field.setBackground(Color.cyan.darker());
      this.add(total_field, q);
      ++ q.y;
      this.add(KappaLayout.createVerticalStrut(15), q);

      // add button panel
      KappaLayout kl = new KappaLayout();
      Panel btn_panel = new Panel(kl);
      Button ok_btn = new Button("OK");
      Button cancel_btn = new Button("Cancel");
      Button clear_btn = new Button("Clear");
      btn_panel.add(ok_btn, "0,0,1,1,,w");
      btn_panel.add(cancel_btn, "1,0,1,1,,w");
      btn_panel.add(clear_btn, "2,0,1,1,,w");
      kl.makeColumnsSameWidth(new int[]{0, 1, 2});
      //kl.makeColumnsSameWidth(0, 1);
      q.x = 0;
      ++q.y;
      q.w = 3;
      q.h = 1;
      q.a = 0;
      q.s = "0";
      this.add(btn_panel, q);
      this.pack();
      System.out.println(kl0);
   }
   
   public Insets getInsets() {
      Insets i = super.getInsets();
      return new Insets(i.top + 10, i.left + 10, i.bottom + 10, i.right + 10);
   }
   
   public static void main(String[] args) {
      Vector v = new Vector();
      v.addElement("123");
      v.addElement("456");
      Dialog d = new MiscDialog(new Frame(), v);
      d.show();
   }
}



