/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
    
/*
 * SearchtoolLastconnectedTableModel.java
 *
 * Created on April 14, 2002, 8:38 PM
 */

package searchtool;

import searchtool.*;
import searchtool.wrappers.*;

/**
 *
 * @author  zoidberg
 * @version
 */
public class SearchtoolLastconnectedTableModel extends SearchtoolTableModel {
    
    public static final int LASTCONNECTED = 8;
    
    private int columncount = 9;
    private static ServerListManager serverListManager;
    
    /** Creates new SearchtoolLastconnectedTableModel */
    public SearchtoolLastconnectedTableModel(ServerListManager LIST) {
        super(LIST);
        serverListManager = LIST;
    }
    
    public int getColumnCount(){
        return columncount;
    }
    
    public String getColumnName(int column){
        if(column < 8)
            return super.getColumnName(column);
        else{
            return "CONNECTIONDATE";
        }
    }
    
    public Object getValueAt(int row, int column) {
        if(column < 8)
            return super.getValueAt(row,column);
        else{
            return ((ServerElement)getElement(row)).getDate().toString();
        }
    }
}
