/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 */

package searchtool;

import java.util.*;
import javax.swing.*;

/**
 * @author thorsten
 *
 *  because static instances of buttons are not allowed and for some reason and i decided NOT to use Actions but 
 *  Actions this class became necessarry.
 *  it is wanted to select all 'world buttons' (see SearchtoolButtonBar) once one
 *  of them has been selected.  this class takes care of this.
 */
public class SynchronButtonController {
	
	public static final int DOWNLOAD_SERVERLIST = 0;
	public static final int MASTERSERVER_FILTER = 1;
	public static final int EDIT_SETTINGS = 2;
	public static final int SEARCH_PLAYERS = 3;

	private Vector[] buttons = new  Vector[4];
	
	public SynchronButtonController(){
		// init
		for(int i = 0; i < buttons.length; i++){
			buttons[i] = new Vector();	
		}	
	}
	
	public void registerButtonOfType(JToggleButton BUTTON ,int TYPE){
		buttons[TYPE].add(BUTTON);	
	}
	
	public void selectButtonsOfType(boolean SELECT, int TYPE){
		for(int i = 0; i < buttons[TYPE].size(); i++){
			((JToggleButton)buttons[TYPE].get(i)).setSelected(SELECT);	
		}	
	}
}
