/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/*
 * HlAddServerToListAction.java
 *
 * Created on February 27, 2002, 2:33 AM
 */

package searchtool.actions;

import searchtool.actions.*;
import searchtool.components.*;
import searchtool.util.*;
import javax.swing.event.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;
import searchtool.*;
import searchtool.wrappers.*;
import searchtool.interfaces.*;

/**
 * add a new server to the currently  on-top list.
 *
 * @author  zoidberg
 * @version
 */

public class AddServerToListActionListener  implements ActionListener {

	private GUI gui;
	private final static JTextField serveraddress = new JTextField();
	private String ip;
	private int port;
	private SearchtoolDialogs.UserEnterServerDialog userEnterServerDialog = new SearchtoolDialogs.UserEnterServerDialog("Add server to list:");
	private ElementController elementController = null;
	private GameController gameController = null;
	private ServerElement dummyServerElement = null;

	/** Creates new AddServerToListAction */
	public AddServerToListActionListener(ElementController elementController, GameController gameController, ServerElement dummyServerElement) {
		this.elementController = elementController;
		this.gameController = gameController;
		this.dummyServerElement = dummyServerElement;
	}

	public void actionPerformed(java.awt.event.ActionEvent actionEvent) {

		IpWrapper ipWrapper = askUserForServer();
		if (ipWrapper != null){
			ServerElement lde = dummyServerElement.getNewServerElement(ipWrapper);
			addElement(lde);
		}
		
		((JToggleButton)actionEvent.getSource()).setSelected(false);
	}
	
	protected IpWrapper askUserForServer(){
		return userEnterServerDialog.askUser();
	}
	
	protected void addElement(ServerElement lde){
		gui = Searchtool.getGui();
		GameFrontend currentFrontend = gui.getCurrentGameFrontend();
		SearchtoolTab selectedTab = currentFrontend.getSelectedTab();
		lde.setResponse(lde.SPECIAL);
		if (selectedTab.getTabType() == selectedTab.FAVOURITE_TAB) {
			lde.setFavouritelist(true);
			elementController.addElement(lde);
			gameController.getFavouritelistTable().selectElement(lde);
			return;
		}
		if (selectedTab.getTabType() == selectedTab.BLACKLIST_TAB) {
			lde.setBlacklist(true);
			elementController.addElement(lde);
			gameController.getBlacklistTable().selectElement(lde);
			return;
		}
		elementController.addElement(lde);
		gameController.getMainTable().selectElement(lde);
	}
}
