/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
 * AddToFavouritesAction.java
 *
 * Created on February 10, 2002, 9:32 PM
 */

package searchtool.actions;

import searchtool.components.SearchtoolTable;
import searchtool.components.*;
import searchtool.util.IconLib;
import searchtool.wrappers.*;
import searchtool.interfaces.*;
import searchtool.util.*;
import searchtool.*;
import searchtool.halflife.wrappers.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.util.*;

/**
 *
 * the action class that does add a selected server to
 * the list of favourite servers. (or removes it)
 *
 * @author  zoidberg
 * @version
 */
public class AddToFavouritesActionListener implements ActionListener {

	private ElementController controller;

	/** Creates new HlAddToFavouritesAction */
	public AddToFavouritesActionListener(ElementController controller) {
		this.controller = controller;
	}

	public void actionPerformed(java.awt.event.ActionEvent actionEvent) {
		GUI gui = Searchtool.getGui();
		GameFrontend currentFrontend = gui.getCurrentGameFrontend();
		SearchtoolTab selectedTab = currentFrontend.getSelectedTab();
		Element selectedElement = ((SelectedElementTracker) selectedTab.getSearchtoolTable().getModel()).getSelectedElement();
		if (selectedElement != null) {
			
			ServerElement newFavourite = null;
			
			if( selectedElement instanceof ServerElement ){
				newFavourite = (ServerElement)selectedElement;
			}	
			if(selectedElement instanceof SearchtoolPlayer ){
				newFavourite = (ServerElement) (((SearchtoolPlayer)selectedElement).getServerElement()) ;	
			}
			if (newFavourite.isFavourite()) {
				newFavourite.setFavouritelist(false);
				controller.addElement(newFavourite);
			} else {
				newFavourite.setFavouritelist(true);
				controller.addElement(newFavourite);
			}
		}
	}
}
