/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/*
 * HlAddToOutsidersAction.java
 *
 * Created on February 10, 2002, 9:39 PM
 */

package searchtool.actions;

import searchtool.components.SearchtoolTable;
import searchtool.components.*;
import searchtool.util.*;
import searchtool.wrappers.*;
import searchtool.interfaces.*;
import searchtool.*;
import searchtool.halflife.wrappers.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.util.*;

/**
 *
 * this is the class that adds the selected server to
 * the blacklist AND of course removes it from the list it
 * came from.
 *
 * @author  zoidberg
 * @version
 */
public class AddToOutsidersActionListener implements ActionListener {

	private ElementController controller;

	/** Creates new HlAddToOutsidersAction */
	public AddToOutsidersActionListener(ElementController controller) {
		this.controller = controller;
	}

	public void actionPerformed(java.awt.event.ActionEvent actionEvent) {
		GUI gui = Searchtool.getGui();
		GameFrontend currentFrontend = gui.getCurrentGameFrontend();
		SearchtoolTab selectedTab = currentFrontend.getSelectedTab();
		SelectedElementTracker tableModel =  ((SelectedElementTracker) selectedTab.getSearchtoolTable().getModel());
		Element selectedElement = tableModel.getSelectedElement();
		if (selectedElement != null) {
			
			ServerElement newFavourite = null;
			
			if( selectedElement instanceof ServerElement ){
				newFavourite = (ServerElement)selectedElement;
			}	
			if(selectedElement instanceof SearchtoolPlayer ){
				newFavourite = (ServerElement) (((SearchtoolPlayer)selectedElement).getServerElement()) ;	
			}
			
			if (newFavourite.isBlacklist()) {
				newFavourite.setBlacklist(false);
				controller.addElement(newFavourite);
				tableModel.setSelectedElement(null);
			} else {
				newFavourite.setBlacklist(true);
				controller.addElement(newFavourite);
				tableModel.setSelectedElement(null);
			}
		}
	}
}
