/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 */

package searchtool.actions;

import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import searchtool.components.*;
import searchtool.wrappers.*;
import searchtool.interfaces.*;
import searchtool.protocol.*;
import searchtool.*;

/**
 * @author thorsten
 *
 */
public class ConnectActionListener implements ActionListener {

	private GUI gui = Searchtool.getGui();
	private SearchtoolProtocol details = null;
	private SearchtoolSettings settings = null;

	public ConnectActionListener(SearchtoolProtocol details, SearchtoolSettings settings) {
		this.details = details;
		this.settings = settings;
	}

	public void actionPerformed(ActionEvent e) {
		final ActionEvent finalEvent = e;

		new Thread(new Runnable() {
			public void run() {
				GameFrontend currentFrontend = gui.getCurrentGameFrontend();
				SearchtoolTab tab = currentFrontend.getSelectedTab();
				SelectedElementTracker tracker = (SelectedElementTracker) tab.getSearchtoolTable().getModel();
				Element selectedElement = tracker.getSelectedElement();
				if (selectedElement != null) {
					SearchtoolConnect connect = new SearchtoolConnect(details, settings);
					if (selectedElement instanceof ServerElement) {
						connect.connect((ServerElement) selectedElement);
					}
					if (selectedElement instanceof Player) {
						connect.connect(((Player) selectedElement).getServerElement());
					}
				}
				if (finalEvent.getSource() instanceof JToggleButton)
					 ((JToggleButton) finalEvent.getSource()).setSelected(false);
			}
		}).start();
	}
}
