/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
    
/*
 * EditSettingsAction.java
 *
 * Created on February 10, 2002, 9:14 PM
 */

package searchtool.actions;

import searchtool.components.*;
import searchtool.components.SearchtoolButtonBar;
import searchtool.util.IconLib;
import javax.swing.event.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.net.*;
import java.util.*;
import searchtool.*;
import searchtool.wrappers.*;
import searchtool.interfaces.*;

/**
 *
 * @author  zoidberg
 * @version
 */
public class EditSettingsActionListener implements ActionListener {
    
    private Component component = null;
    private String tabName = "settings";
    private SynchronButtonController controller = null;
    
    /** Creates new EditSettingsAction */
    public EditSettingsActionListener(JPanel component, String tabName, SynchronButtonController controller) {
    	this.component = component;
    	this.tabName = tabName;
    	this.controller = controller;
    }
    
    public void actionPerformed(java.awt.event.ActionEvent actionEvent) {
        GUI gui = Searchtool.getGui();   
        GameFrontend currentFrontend = gui.getCurrentGameFrontend();
        if(currentFrontend.tabIsOpen(tabName)){
            // close tab
            currentFrontend.removeTab(tabName);
            // deselect button
           controller.selectButtonsOfType(false,controller.EDIT_SETTINGS);
        }
        else{
            currentFrontend.addTab(tabName,component);
            // select button
            controller.selectButtonsOfType(true,controller.EDIT_SETTINGS);
            
            
        }
    }
}
