/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 */

/*
 * HlFilterServerlistAction.java
 *
 * Created on February 10, 2002, 9:27 PM
 */

package searchtool.actions;

import searchtool.components.*;
import searchtool.util.IconLib;
import javax.swing.event.*;
import javax.swing.*;
import java.awt.event.*;
import java.net.*;
import java.lang.*;
import java.util.*;
import java.io.*;
import searchtool.*;
import searchtool.wrappers.*;
import searchtool.interfaces.*;
import searchtool.actions.*;

/**
 *
 * @author  zoidberg
 * @version
 */
public class FilterServerlistActionListener implements ActionListener {

	/** Creates new HlFilterServerlistAction */
	public FilterServerlistActionListener() {
	}

	public void actionPerformed(java.awt.event.ActionEvent actionEvent) {

		// check what tab is open and do the proper things.
		GUI gui = Searchtool.getGui();
		GameFrontend currentFrontend = gui.getCurrentGameFrontend();
		SearchtoolTab selectedTab = currentFrontend.getSelectedTab();
		ElementListManager manager = ((SelectedElementTracker)selectedTab.getSearchtoolTable().getModel()).getListManager();		
		changeSettings(manager);
	}

	private void changeSettings(ElementListManager listmanager) {
		// change settings if button-tracker exists
		ButtonTracker settings = listmanager.getButtonTracker();
		if (settings != null) {
			if (settings.getValue(ButtonTracker.LOCAL_FILTER_BUTTON).equals(ButtonTracker.ENABLED)) {
				// change settings
				settings.setValue(ButtonTracker.LOCAL_FILTER_BUTTON, ButtonTracker.DISABLED);
			} else {
				// change settings
				settings.setValue(ButtonTracker.LOCAL_FILTER_BUTTON, ButtonTracker.ENABLED);
			}
			settings.save();
		}
	}
}
