/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/*
 *
 * Created on February 10, 2002, 9:41 PM
 */

package searchtool.actions;

import java.io.*;
import java.awt.event.*;
import javax.swing.*;

import searchtool.*;
import searchtool.components.*;
import searchtool.protocol.*;
import searchtool.wrappers.*;
import searchtool.interfaces.*;

/**
 * this class builds the details frame for a selected server.
 */

public class GetDetailsActionListener implements ActionListener {

	private GUI gui;
	private SearchtoolProtocol ping,rules,details,players;
	private File rulesConfigFile;
	private SearchtoolSettings settings;

	public GetDetailsActionListener(SearchtoolProtocol ping, SearchtoolProtocol rules, SearchtoolProtocol details, SearchtoolProtocol players, File rulesConfigFile,SearchtoolSettings settings) {
		this.ping = ping;
		this.rules = rules;
		this.details = details;
		this.players = players;
		this.settings = settings;
		this.rulesConfigFile = rulesConfigFile;
	}

	public void actionPerformed(ActionEvent e) {
		gui = Searchtool.getGui();
		GameFrontend currentFrontend = gui.getCurrentGameFrontend();
		SearchtoolTab selectedTab = currentFrontend.getSelectedTab();
		SelectedElementTracker model = (SelectedElementTracker) selectedTab.getSearchtoolTable().getModel();
		Element element = model.getSelectedElement();

		DetailsDialog dialog = new DetailsDialog(ping,rules,details,players,element,rulesConfigFile,settings);
		dialog.show();

		if (e.getSource() instanceof JToggleButton)
			 ((JToggleButton) e.getSource()).setSelected(false);
	}

}
