/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
    
/*
 * HelpAction.java
 *
 * Created on February 22, 2002, 3:00 AM
 */

package searchtool.actions;

import searchtool.components.*;
import searchtool.wrappers.*;
import searchtool.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 *
 * display the dialog (more a monologue) that describes the functionality
 * of all buttons.
 * @author  zoidberg
 * @version
 */

public class HelpActionListener implements ActionListener {
    
    private String pathToHelpFile = null;
    
    /** Creates new HelpAction */
    public HelpActionListener(String pathToHelpFile) {
    	this.pathToHelpFile = pathToHelpFile;
    }
    
    /**
     * displays the dialog (more a monologue) that describes the functionality
     * of all buttons.
     */
    public void actionPerformed(java.awt.event.ActionEvent actionEvent) {
                            
        SearchtoolDialogs.HelpDialog helpDialog = new SearchtoolDialogs.HelpDialog(pathToHelpFile);
        // show help dialog with gpl option
        helpDialog.showHelpDialog(true);
        
        if(actionEvent != null)
       		((JToggleButton)actionEvent.getSource()).setSelected(false);       
    }    
}
