/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 */

/*
 *
 * Created on February 10, 2002, 9:31 PM
 */

package searchtool.actions;

import searchtool.components.SearchtoolButtonBar;
import searchtool.util.IconLib;
import javax.swing.event.*;
import javax.swing.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;
import searchtool.*;
import searchtool.wrappers.*;
import searchtool.interfaces.*;

/**
 *
 * @author  zoidberg
 * @version
 */
public class SetMasterserverFilterActionListener implements ActionListener {
    
    private SearchtoolSettings settings = null;
    private SynchronButtonController controller = null;
    
    public SetMasterserverFilterActionListener(SearchtoolSettings settings,SynchronButtonController controller) {
    	this.settings = settings;
    	this.controller = controller;
    }
    
    public void actionPerformed(java.awt.event.ActionEvent actionEvent) {
        if ( settings.getValueAsInt(SearchtoolSettings.MASTERLEVEL_FILTER) == 0) {
            settings.setValue(SearchtoolSettings.MASTERLEVEL_FILTER ,SearchtoolSettings.ENABLED);   
            controller.selectButtonsOfType(true,controller.MASTERSERVER_FILTER);         
        }
        else{
            settings.setValue(SearchtoolSettings.MASTERLEVEL_FILTER, SearchtoolSettings.DISABLED);  
        	controller.selectButtonsOfType(false,controller.MASTERSERVER_FILTER);   
        }
        settings.save();
    }
}

