/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 */

package searchtool.components;

import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;
import searchtool.util.*;
/**
 * @author thorsten
 *
 */

public class SearchtoolPopupMenu extends JPopupMenu {

	private JMenuItem makeFavourite, makeBlacklist, connect, getInfo;
	private SearchtoolButtonBar buttonBar;

	public SearchtoolPopupMenu(SearchtoolButtonBar buttonbar) {
		super();
		buttonBar = buttonbar;
		ActionListener listener = null;
		listener = buttonBar.getActionListener(buttonBar.MAKE_FAVOURITE);
		if (listener != null) {
			makeFavourite = add("make favourite");
			makeFavourite.addActionListener(listener);
			makeFavourite.setIcon(IconLib.getMakeFavouriteIconSmall());
			makeFavourite.setText("add to/remove from favourites");
			listener = null;
		}
		listener = buttonBar.getActionListener(buttonBar.MAKE_OUTSIDER);
		if (listener != null) {
			makeBlacklist = add("make blacklist");
			makeBlacklist.addActionListener(listener);
			makeBlacklist.setIcon(IconLib.getMakeOutsiderIconSmall());
			makeBlacklist.setText("add to/remove from blacklist");
			listener = null;
		}
		listener = buttonBar.getActionListener(buttonBar.CONNECT);
		if (listener != null) {
			connect = add("connect");
			connect.addActionListener(listener);
			connect.setIcon(IconLib.getConnectIconSmall());
			connect.setText("connect");
			listener = null;
		}
		listener = buttonBar.getActionListener(buttonBar.DISPLAY_DETAILS);
		if (listener != null) {
			getInfo = add("get details");
			getInfo.addActionListener(listener);
			getInfo.setIcon(IconLib.getGetDetailsIconSmall());
			getInfo.setText("display details");
			listener = null;
		}
	}
}
