/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

package searchtool.components;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import searchtool.util.*;

/**
 * @author thorsten
 * a splashscreen window displayed at startup of searchtool.
 */
public class SearchtoolSplash extends JWindow{

	private JPanel contentPane;
	private JProgressBar progressBar = null;

	public SearchtoolSplash() {
		contentPane = new JPanel();
		contentPane.setLayout(new BorderLayout());
		Border bd1 = BorderFactory.createBevelBorder(BevelBorder.RAISED);
		Border bd2 = BorderFactory.createEtchedBorder();
		Border bd3 = BorderFactory.createCompoundBorder(bd1, bd2);
		contentPane.setBorder(bd3);
		ImageIcon icon = IconLib.getLogoIcon();
		JLabel iconLabel = new JLabel(icon);
		iconLabel.setBackground(Color.lightGray);
		contentPane.add(iconLabel,BorderLayout.CENTER);
		setContentPane(contentPane);
		contentPane.setPreferredSize(new Dimension(300, 270));
		setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
		pack();
		int screenWidth = Toolkit.getDefaultToolkit().getScreenSize().width;
		int screenHeight = Toolkit.getDefaultToolkit().getScreenSize().height;
		setLocation(screenWidth / 2 - getSize().width / 2, screenHeight / 2 - getSize().height / 2);
	}

	public void setProgressBar(JProgressBar progressBar) {
		progressBar.setPreferredSize(new Dimension(280, 22));
		contentPane.add(progressBar,BorderLayout.SOUTH);
		contentPane.validate();
		this.progressBar = progressBar;
	}

	public void clearProgressBar(){
		if ( progressBar != null ){
			progressBar.setString("");
			progressBar.setValue(0);
			progressBar.setStringPainted(true);
			progressBar.repaint();			
		}
	}

	public void setProgressBarText(String text) {
		if (progressBar != null) {
			progressBar.setString(text);
			progressBar.setStringPainted(true);
		}
	}
}
