/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package searchtool.gamespy;

import searchtool.*;
import searchtool.interfaces.*;
import searchtool.protocol.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.text.*;
import searchtool.wrappers.*;
import searchtool.util.*;

/**
 * @author thorsten
 */
public class GamespyPing extends SearchtoolProtocol {

	private static String query_string = "\\echo\\1";
	private static byte[] sndbyte = query_string.getBytes();

	public GamespyPing(ServerElement element) {
		super(element);
	}

	public GamespyPing() {
	}

	public void fill() throws Exception {
		DatagramSocket socket = null;
		DatagramPacket snd_packet = null;
		DatagramPacket get_packet = null;
		InetAddress inet_address = null;
		try {
			byte[] getbyte = new byte[0];
			inet_address = InetAddress.getByName(super.getServerElement().getIp());
			//System.out.println(inet_address.toString()+ "  " + super.getServerElement().getPort().intValue());
			socket = new DatagramSocket();
			snd_packet = new DatagramPacket(sndbyte, sndbyte.length, inet_address, super.getServerElement().getPort().intValue());
			get_packet = new DatagramPacket(getbyte, getbyte.length);
			socket.send(snd_packet);
			long past = System.currentTimeMillis();
			socket.setSoTimeout(1000);
			socket.receive(get_packet);
			long now = System.currentTimeMillis();
			super.getServerElement().setPing((int) (now - past));
			//super.getServerElement().setResponse(ServerElement.RESPONSE_POSITIVE);
			socket.close();
		} catch (Exception e) {
			socket.close();
			throw e;
		}
	}
}
