package searchtool.halflife;

import searchtool.*;
import searchtool.wrappers.*;
import searchtool.halflife.wrappers.*;

/**
 * @author thorsten
 * 
 *  support one more column.
 *
 */
public class HlResultTableModel extends SearchtoolResultTableModel {

	public static final String SECURE_COLUMN = "SECURE";

	public HlResultTableModel(ServerListManager listManager) {
		super(listManager);
	}

	public int getColumnCount() {
		return 9;
	}

	SearchtoolPlayer tmpElement = null;
	public synchronized Object getValueAt(int row, int column) {
		tmpElement = (SearchtoolPlayer)getElement(row);
		if (tmpElement != null) {
			if (column == 8)
				return ((HlServerElement)tmpElement.getServerElement()).getSecure();
			else
				return super.getValueAt(row, column);
		}
		return null;
	}

	public synchronized String getColumnName(int column) {
		if (column == 8)
			return SECURE_COLUMN;
		else
			return super.getColumnName(column);
	}
}
