/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 */

/**
 * this class extends SearchtoolTableCellRenderer and supports
 * three halflife specific columns: SECURE_SERVER,PALADIN,CHEATINGDEATH
 *
 */
package searchtool.halflife;

import searchtool.util.IconLib;
import searchtool.*;
import searchtool.wrappers.*;
import javax.swing.*;
import java.awt.*;
import java.util.*;
import javax.swing.table.*;
import searchtool.interfaces.*;
import searchtool.halflife.wrappers.*;

public class HlTableCellRenderer extends SearchtoolTableCellRenderer implements TableCellRenderer{
    
    public static int SECURE_COLUMN=HlTableModel.SECURE;
    //SERVERNAME_COLUMN= HlTableModel.SERVERNAME;
    
    // to avoid unnecessary method calls i create new references in this class
    private JLabel emptyLabel = getEmptyLabel();
    private JLabel redLabel = getRedLabel();
    private JLabel greenLabel = getGreenLabel();
    private JLabel secureLabel = null;
    
    
    public HlTableCellRenderer(){
        super();
        secureLabel = new JLabel(IconLib.getSecureIcon());
        secureLabel.setToolTipText("unsecure server");
    }
    
    public Component getTableCellRendererComponent(JTable table,Object value,boolean isSelected,boolean hasFocus,int row,int column){
        
        // <TMP>
        if ( value == null )
            return getEmptyLabel();
        else if(column == SECURE_COLUMN){
            // </TMP>
            
            if(((Byte)value).equals(HlServerElement.SECURE)){
                if(isSelected){
                    JPanel returnMe = new JPanel(new GridLayout(1,1));
                    returnMe.setBackground(Color.darkGray);
                    returnMe.add(emptyLabel);
                    return returnMe;
                }
                // secure server
                return emptyLabel;
            }
            else{
                if(isSelected){
                    JPanel returnMe = new JPanel(new GridLayout(1,1));
                    returnMe.setBackground(Color.darkGray);
                    returnMe.add(secureLabel);
                    return returnMe;
                }
                // unsecure server
                return secureLabel;
            }
        }        
        else{
            return super.getTableCellRendererComponent(table,value,isSelected,hasFocus,row,column);
        }
    }
}

