/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 
package searchtool.halflife;

import searchtool.*;
import searchtool.wrappers.*;

/**
 * @author thorsten
 *
 */
public class HlTableHeaderSortingController extends SearchtoolTableHeaderSortingController{
	
	HlTableHeaderSortingController(SelectedElementTracker model, ButtonTracker buttonTracker){
		super(model, buttonTracker);
	}
	
	protected void checkSupportedColumn(int selected_column) {

		if (selected_column == SERVERNAME
			|| selected_column == IP
			|| selected_column == PING
			|| selected_column == MAP
			|| selected_column == CURRENTPLAYERS
			|| selected_column == MAXPLAYERS
			|| selected_column == LASTCONNECTED + 1) {
			doColumn(selected_column);
		}
	}
	
	/**
	 * comparator interface's method.
	 * sort depending on the current settings.
	 */
	public int compare(Object O, Object O1) {
		o = (ServerElement) O;
		o1 = (ServerElement) O1;
		switch (buttonTracker.getValueAsInt(ButtonTracker.SORTING_CRITERION)) {
			case SearchtoolTableModel.SERVERNAME :
				{
					if (o.getMap().equals("-"))
						return 1;
					if (o1.getMap().equals("-"))
						return -1;
					return o.getServername().compareTo(o1.getServername());
				}
			case SearchtoolTableModel.IP :
				{
					return o.compareTo(o1);
				}
			case SearchtoolTableModel.PING :
				{
					x = o.getPing().intValue() - o1.getPing().intValue();
					if (x == 0)
						return o.compareTo(o1);
					else
						return x;
				}
			case SearchtoolTableModel.MAP :
				{
					if (o.getMap().equals("-"))
						return 1;
					if (o1.getMap().equals("-"))
						return -1;
					x = o.getMap().compareTo(o1.getMap());
					if (x == 0)
						return o.compareTo(o1);
					else
						return x;
				}
			case SearchtoolTableModel.CURRENTPLAYERS :
				{
					x = o1.getCurrentplayers().intValue() - o.getCurrentplayers().intValue();
					if (x == 0)
						return o.compareTo(o1);
					else
						return x;
				}
			case SearchtoolTableModel.MAXPLAYERS :
				{
					x = o1.getMaxplayers().intValue() - o.getMaxplayers().intValue();
					if (x == 0)
						return o.compareTo(o1);
					else
						return x;
				}
			case LASTCONNECTED +1 :
				{
					long x = o1.getDate().getTime() - o.getDate().getTime();
					if (x == 0)
						return o.compareTo(o1);
					else
						return (int) x;
				}
		}
		return 0;
	}
}
