/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

package searchtool.halflife;

import searchtool.*;
import searchtool.wrappers.*;
import java.util.*;
import searchtool.halflife.wrappers.*;

/**
 * the halflife extension of SearchtoolTableModel in order
 * to support more columns.
 */
public class HlTableModel extends SearchtoolTableModel {
	public static final int SECURE = 8, PLAYER_RESULTS = 9;
	private HlServerListManager mhl;
	private int columncount;

	public HlTableModel(HlServerListManager MHL) {
		super(MHL);
		columncount = 9;
		mhl = (HlServerListManager) getListManager(); // equals MHL parameter
	}

	// override few methods

	public int getColumnCount() {
		return columncount;
	}

	public String getColumnName(int column) {
		if (column < 8)
			return super.getColumnName(column);
		else {
			if (column == SECURE)
				return "SECURE";
		}
		return null;
	}

	public Object getValueAt(int row, int column) {
		if (column <= super.PASSWORD){
			return super.getValueAt(row, column);
		}
		else{
			// here check which list to show
			if (super.buttonTracker != null && super.buttonTracker.filterEnabled()) {
				if ( row >= filteredList.length )
					return null;
				return ((HlServerElement) filteredList[row]).getSecure();
			} else {
				if ( row >= completeList.length )
					return null;
				return ((HlServerElement) completeList[row]).getSecure();
			}
		}
	}
}
