/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/*
 * HL_Details.java
 *
 * Created on December 16, 2001, 2:18 PM
 */

package searchtool.halflife.protocol;

import searchtool.interfaces.*;
import searchtool.protocol.*;
import searchtool.*;
import searchtool.halflife.wrappers.*;
import searchtool.wrappers.*;
import java.io.*;
import java.net.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.*;
/**
 * this class runs the 'infostring' request and parses the received data.
 *
 * in order to increase performance i did not use
 * those nice StringTokenizers and such.  (programming like in the middle ages 8)
 *
 * @author  zoidberg
 * @version
 */
public class HL_Details extends SearchtoolProtocol {

	// all fields that have values assigned to
	// in the query response.
	private static final byte[] PROTOCOL,
		CURRENTPLAYERS,
		PROXYTARGET,
		LAN,
		MAXPLAYERS,
		GAMEDIR,
		DESCRIPTION,
		SERVERNAME,
		CURRENTMAP,
		SERVERTYPE,
		PASSWORD,
		OPERATINGSYSTEM,
		SECURE,
		RUNNINGMOD,
		MODVERSION,
		SVONLY,
		CLDLL,
		SERVERADDRESS,
		PROXY,
		PROXYADDRESS;

	private static final byte RESPONSE_SEPARATOR = 92; // the separator of the response string: "\"
	private static byte[] request = null;
	private int position = 24; // skip yyyyinfostringresponse\

	static {
		PROTOCOL = "protocol".getBytes();
		CURRENTPLAYERS = "players".getBytes();
		PROXYTARGET = "proxytarget".getBytes();
		LAN = "lan".getBytes();
		MAXPLAYERS = "max".getBytes();
		GAMEDIR = "gamedir".getBytes();
		DESCRIPTION = "description".getBytes();
		SERVERNAME = "hostname".getBytes();
		CURRENTMAP = "map".getBytes();
		SERVERTYPE = "type".getBytes();
		PASSWORD = "password".getBytes();
		OPERATINGSYSTEM = "os".getBytes();
		SECURE = "secure".getBytes();
		RUNNINGMOD = "mod".getBytes();
		MODVERSION = "modversion".getBytes();
		SVONLY = "svonly".getBytes();
		CLDLL = "cldll".getBytes();
		SERVERADDRESS = "address".getBytes();
		PROXY = "proxy".getBytes();
		PROXYADDRESS = "proxyaddress".getBytes();
	}

	/** Creates new HL_Details */
	public HL_Details(HlServerElement HLD) {
		super(HLD);
		if (request == null) {
			try {
				ByteArrayOutputStream out = new ByteArrayOutputStream();
				out.write(255);
				out.write(255);
				out.write(255);
				out.write(255);
				out.write("infostring".getBytes());
				out.write(0);
				request = out.toByteArray();
				out.close();
			} catch (Exception uee) {
				uee.printStackTrace();
			}
		}
	}

	public HL_Details() {
		if (request == null) {
			try {
				ByteArrayOutputStream out = new ByteArrayOutputStream();
				out.write(255);
				out.write(255);
				out.write(255);
				out.write(255);
				out.write("infostring".getBytes());
				out.write(0);
				request = out.toByteArray();
				out.close();
			} catch (Exception uee) {
				uee.printStackTrace();
			}
		}
	}

	private byte[] getValueFor(byte[] VARIABLE, byte[] content) {
		for (position = 24; position < 400; position++) { // skip yyyyinfostringresponse\
			if (position >= content.length - 1)
				break; // end of response
			if (content[position] == VARIABLE[0]) {
				for (int i = 1; i < VARIABLE.length; i++) {
					if (content[position + i] != VARIABLE[i]) {
						break;
					}
					if (i == VARIABLE.length - 1) {
						position = position + VARIABLE.length + 1; // skip variable and separator
						// check if skipped char was separator, if not ---> break               
						if (content[position - 1] != RESPONSE_SEPARATOR) {
							break;
						}
						int tmp = position;
						while (content[position] != RESPONSE_SEPARATOR && content[position] != 0)
							position++;
						byte[] returnme = new byte[position - tmp];
						System.arraycopy(content, tmp, returnme, 0, returnme.length);
						//System.out.println(new String(VARIABLE) + "              " + new String(returnme));
						return returnme;
					}
				}
			}
		}
		return null;
	}

	public void fill() throws Exception {

		DatagramSocket socket = null;
		DatagramPacket snd_packet = null;
		DatagramPacket get_packet = null;
		InetAddress inet_address = null;
		try {
			inet_address = InetAddress.getByName(super.getServerElement().getIp());
			socket = new DatagramSocket();
			byte[] content = new byte[5000];
			snd_packet = new DatagramPacket(request, request.length, inet_address, super.getServerElement().getPort().intValue());
			get_packet = new DatagramPacket(content, content.length);
			socket.send(snd_packet);
			socket.setSoTimeout(2000);
			socket.receive(get_packet);

			byte[] tmpbyte;
			/* = getValueFor(PROTOCOL);
			            if(tmpbyte != null){
			                super.getServerElement().setProtocolVersion(new String(tmpbyte));
			            }
			            */
			tmpbyte = getValueFor(CURRENTPLAYERS, content);
			if (tmpbyte != null) {
				super.getServerElement().setCurrentplayers(Integer.parseInt(new String(tmpbyte)));
			}
			/*
			tmpbyte = getValueFor(PROXY);
			if(tmpbyte != null){
			    if(new String(tmpbyte).equals("0"))
			        hld.setProxy(false);
			    else
			        hld.setProxy(true);
			}
			*/
			/*
			tmpbyte = getValueFor(PROXYADDRESS);
			if(tmpbyte != null)
			    hld.setProxyAddress(new String(tmpbyte));
			    */
			/*
			tmpbyte = getValueFor(PROXYTARGET);
			if(tmpbyte != null)
			hld.setProxyTarget(new String(tmpbyte));
			*/
			/*
			tmpbyte = getValueFor(LAN);
			if(tmpbyte != null){
			if(new String(tmpbyte).equals("0"))
			    hld.setLan(false);
			else
			    hld.setLan(true);
			}
			*/
			tmpbyte = getValueFor(MAXPLAYERS, content);
			if (tmpbyte != null)
				super.getServerElement().setMaxplayers(Integer.parseInt(new String(tmpbyte)));
			tmpbyte = getValueFor(GAMEDIR, content);
			if (tmpbyte != null)
				super.getServerElement().setMod(new String(tmpbyte));

			/*
			            tmpbyte = getValueFor(DESCRIPTION);
			            if(tmpbyte != null)
			               super.getServerElement().setDescription(new String(tmpbyte));
			               */

			tmpbyte = getValueFor(SERVERNAME, content);
			if (tmpbyte != null)
				super.getServerElement().setServername(new String(tmpbyte));
			tmpbyte = getValueFor(CURRENTMAP, content);
			if (tmpbyte != null)
				super.getServerElement().setMap(new String(tmpbyte));
			tmpbyte = getValueFor(SERVERTYPE, content);
			if (tmpbyte != null) {
				if (new String(tmpbyte).equals("d"))
					super.getServerElement().setServerType("dedicated");
				else
					super.getServerElement().setServerType("listen");
			}
			tmpbyte = getValueFor(PASSWORD, content);
			if (tmpbyte != null) {
				if (new String(tmpbyte).equals("0"))
					super.getServerElement().setPassword(ServerElement.NO_PASSWD);
				else
					super.getServerElement().setPassword(ServerElement.PASSWD_REQUIRED);
			}
			tmpbyte = getValueFor(OPERATINGSYSTEM, content);
			if (tmpbyte != null) {
				if (new String(tmpbyte).equals("l"))
					super.getServerElement().setOperatingSystem("linux");
				else
					super.getServerElement().setOperatingSystem("window$");
			}
			tmpbyte = getValueFor(SECURE, content);
			if (tmpbyte != null) {
				if (new String(tmpbyte).equals("0"))
					 ((HlServerElement) super.getServerElement()).setSecure(HlServerElement.UNSECURE);
				else
					 ((HlServerElement) super.getServerElement()).setSecure(HlServerElement.SECURE);
			}
			/*
			tmpbyte = getValueFor(RUNNINGMOD);
			if(tmpbyte != null){
			    if(new String(tmpbyte).equals("0"))
			        hld.setRunningMod(false);
			    else
			        hld.setRunningMod(true);
			}
			*/
			/*
			tmpbyte = getValueFor(MODVERSION);
			if(tmpbyte != null)
			    hld.setModVersion(new String(tmpbyte));
			    */
			/*
			tmpbyte = getValueFor(SVONLY);
			if(tmpbyte != null){
			if(new String(tmpbyte).equals("0"))
			    hld.setSvonly(false);
			else
			    hld.setSvonly(true);
			}
			*/
			/*
			tmp = new String(getValueFor(CLDLL));
			if(tmp != null){
			    if(tmp.equals("0"))
			        hld.setCldll(false);
			    else
			        hld.setCldll(true);
			}
			 */
		} catch (Exception e) {
			socket.close();
			throw e;
		}
		super.setTimedout(false);

	}
}
