/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
 * HL_Players.java
 *
 * Created on December 16, 2001, 2:26 PM
 */

package searchtool.halflife.protocol;

import searchtool.interfaces.*;
import searchtool.protocol.*;

import java.io.*;
import java.net.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.*;

import searchtool.*;
import searchtool.halflife.wrappers.*;
import searchtool.wrappers.*;
/**
 *
 * @author  zoidberg
 * @version
 */
public class HL_Players extends SearchtoolProtocol {
	private byte[] getbyte;
	private int currentplayers;
	private static byte[] request = null;

	/** Creates new HL_Players */
	public HL_Players(ServerElement hld) {
		super(hld);
		if (request == null) {
			try {
				ByteArrayOutputStream out = new ByteArrayOutputStream();
				out.write(255);
				out.write(255);
				out.write(255);
				out.write(255);
				out.write("players".getBytes());
				out.write(0);
				request = out.toByteArray();
				out.close();
			} catch (Exception uee) {
				uee.printStackTrace();
			}
		}
	}

	public HL_Players() {
		if (request == null) {
			try {
				ByteArrayOutputStream out = new ByteArrayOutputStream();
				out.write(255);
				out.write(255);
				out.write(255);
				out.write(255);
				out.write("players".getBytes());
				out.write(0);
				request = out.toByteArray();
				out.close();
			} catch (Exception uee) {
				uee.printStackTrace();
			}
		}
	}

	public void fill() throws Exception {
		DatagramSocket socket = null;
		DatagramPacket snd_packet = null;
		DatagramPacket get_packet = null;
		InetAddress inet_address = null;
		try {
			inet_address = InetAddress.getByName(super.getServerElement().getIp());
			socket = new DatagramSocket();
			getbyte = new byte[5000];
			snd_packet = new DatagramPacket(request, request.length, inet_address, super.getServerElement().getPort().intValue());
			get_packet = new DatagramPacket(getbyte, getbyte.length);
			socket.send(snd_packet);
			socket.setSoTimeout(2000);
			socket.receive(get_packet);

			ByteArrayInputStream byteIn = new ByteArrayInputStream(getbyte);
			StringBuffer stringBuffer = new StringBuffer();
			byteIn.skip(4);
			int x = byteIn.read();
			if ( (char)x != 'D' ){
				//System.out.println("wrong package: " + (char)x);
				//System.out.println(new String(getbyte).trim() + "\n");
				throw new Exception("wrong package received"); 
			}
			currentplayers = byteIn.read();
			//System.out.println(new String(getbyte)+"\n");
			String[] playerArray = new String[currentplayers];
			int read;
			for (int i = 0; i < currentplayers; i++) {
				byteIn.skip(1);
				while (true) {
					read = byteIn.read();
					if (read == 0)
						break;
					stringBuffer.append((char) read);
				}
				// we ommit the rest of the data.
				byteIn.skip(8);
				playerArray[i] = stringBuffer.toString();
				// clear
				stringBuffer.delete(0, stringBuffer.length());
			}
			// fine
			super.getServerElement().setCurrentPlayerList(playerArray);
			byteIn.close();
		} catch (Exception e) {
			socket.close();
			throw e;
		}
		super.setTimedout(false);
	}
}
