/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/*
 * HL_Rules.java
 *
 * Created on December 16, 2001, 2:29 PM
 */

package searchtool.halflife.protocol;

import searchtool.interfaces.*;
import searchtool.halflife.wrappers.*;
import searchtool.protocol.*;
import java.io.*;
import java.net.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.lang.*;
import java.text.*;
// thirdparty
import gnu.trove.*;

/**
 *
 * @author  zoidberg
 * @version
 */

public class HL_Rules extends SearchtoolProtocol {

	private byte[] getbyte;
	private boolean timedout = false;
	private static byte[] request = null;

	/** Creates new HL_Rules */
	public HL_Rules(HlServerElement hld) {
		super(hld);
		if (request == null) {
			try {
				ByteArrayOutputStream out = new ByteArrayOutputStream();
				out.write(255);
				out.write(255);
				out.write(255);
				out.write(255);
				out.write("rules".getBytes());
				out.write(0);
				request = out.toByteArray();
				out.close();
			} catch (Exception uee) {
				uee.printStackTrace();
			}
		}
	}
	public HL_Rules() {
		if (request == null) {
			try {
				ByteArrayOutputStream out = new ByteArrayOutputStream();
				out.write(255);
				out.write(255);
				out.write(255);
				out.write(255);
				out.write("rules".getBytes());
				out.write(0);
				request = out.toByteArray();
				out.close();
			} catch (Exception uee) {
				uee.printStackTrace();
			}
		}
	}

	public boolean hasTimedout() {
		return timedout;
	}

	public void fill() throws Exception {
		DatagramSocket socket = null;
		try {
			byte[] sndbyte = null;
			byte[] getbyte = null;
			byte[] secondPackage = null;
			ByteArrayOutputStream completeOut = new ByteArrayOutputStream();
			THashMap rulesMap = new THashMap();
			InetAddress inet_address = InetAddress.getByName(super.getServerElement().getIp());
			socket = new DatagramSocket();
			DatagramPacket snd_packet = new DatagramPacket(request, request.length, inet_address, super.getServerElement().getPort().intValue());
			socket.send(snd_packet);
			socket.setSoTimeout(5000);
			getbyte = new byte[1400];
			DatagramPacket get_packet = null;

			// i only expect two packages.
			for (int i = 0; i < 2; i++) {

				get_packet = new DatagramPacket(getbyte, getbyte.length);
				socket.receive(get_packet);

				int indexE = containsYYYYE(getbyte);
				// if only one package response
				if (indexE == 0) {
					for (int j = 7; j < 1400; j++)
						completeOut.write(getbyte[j]);
					break;
				}
				// more than one package
				else if (indexE == 9) {
					for (int j = 16; j < 1400; j++)
						completeOut.write(getbyte[j]);
					getbyte = new byte[1400];
				} else {
					secondPackage = getbyte;
					getbyte = new byte[1400];
				}
			}

			if (secondPackage != null) {
				for (int j = 9; j < 1400; j++) {
					completeOut.write(secondPackage[j]);	
				}
			}

			byte byteread;
			ByteArrayInputStream bytein = new ByteArrayInputStream(completeOut.toByteArray());
			DataInputStream in = new DataInputStream(bytein);
			//System.out.println(new String(completeOut.toByteArray()).trim());
			StringBuffer rulename = new StringBuffer();
			StringBuffer rulevalue = new StringBuffer();

						while (in.available() > 0) {
							byteread = in.readByte();
							rulename.delete(0, rulename.length());
							rulevalue.delete(0, rulevalue.length());
							while (true) {
								if (byteread == 0)
									break;
								rulename.append((char) byteread);
								byteread = in.readByte();
							}
							//System.out.println(rulename.toString().trim());
							// end of rule name          
							if ( in.available() > 0 )      
								byteread = in.readByte();
							else
								break;
							while (true) {
								if (byteread == 0)
									break;
								rulevalue.append((char) byteread);
								byteread = in.readByte();
							}
							// end of rule value
							rulesMap.put(rulename.toString(), rulevalue.toString());
						}
			
			completeOut.close();
			bytein.close();
			in.close();
			socket.close();
			super.getServerElement().setRulesMap(rulesMap);

		} catch (Exception e) {
			socket.close();
			//e.printStackTrace();
			throw e;
		}
		super.setTimedout(false);
	}

	private int containsYYYYE(byte[] response) {
		int charE = 69;
		int length = response.length - 5;
		for (int i = 0; i < length; i++) {
			if (response[i] == -1 && response[i + 1] == -1 && response[i + 2] == -1 && response[i + 3] == -1 && response[i + 4] == charE) {
				return i;
			}
		}
		return -1;
	}
}
