/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package searchtool.tribes2;

import searchtool.*;
import searchtool.unreal_tournament.protocol.*;
import searchtool.tribes2.wrappers.*;
import searchtool.components.*;
import searchtool.gamespy.*;
import searchtool.tribes2.protocol.*;
import searchtool.actions.*;
import searchtool.unreal_tournament.protocol.*;

/**
 * @author thorsten
 *
 */
public class Tribes2GameController extends GameController {
	
	public Tribes2GameController(String gamePrefix){
		super(gamePrefix);
		
		// override settings
		super.settings = new Tribes2Settings(super.configFile);
		super.settings.load();
		// override component due to different settings object
		super.editSettingsPanel = new SearchtoolSettingsPanel(settings,"searchtool/files/" + gamePrefix + "_settings.html" );
		// override component due to different protocol class
		super.searchPlayersPanel = new SearchPlayersPanel( this, new GamespyPlayers(), new UnrealTournamentDetails() );
	}

	protected void initActionListeners(){
		super.initActionListeners();		
		super.getDetails = null;
		super.getDetails = new GetDetailsActionListener(new Tribes2Ping(), new UnrealTournamentRules(), new UnrealTournamentDetails(), new GamespyPlayers(), rulesConfigFile,settings);
		super.pingServerList = null;
		super.pingServerList = new PingServersActionListener(this, super.settings, new Tribes2Ping(), new UnrealTournamentDetails(), new UnrealTournamentRules());
		super.getServerlist = null;
		super.getServerlist = new DownloadServersActionListener(super.elementController, this, super.buttonController, new Tribes2MasterQuery( (Tribes2Settings)super.settings, super.gamePrefix));
	}

}
