/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package searchtool.tribes2.protocol;

import java.io.*;
import java.net.*;
import java.util.*;

import searchtool.components.*;
import searchtool.wrappers.*;
import searchtool.tribes2.wrappers.*;
import searchtool.protocol.*;

// thirdparty
import gnu.trove.*;

/**
 * @author thorsten
 *
 */
public class Tribes2Ping extends SearchtoolProtocol {

	private static byte[] sndbyte = null;
	private byte[] getbyte = new byte[50];
	private DatagramSocket socket = null;
	private DatagramPacket snd_packet = null;
	private DatagramPacket get_packet = null;
	private InetAddress inet_address = null;

	public Tribes2Ping(ServerElement element) {
		super(element);
		if (sndbyte == null) {
			try {
				ByteArrayOutputStream out = new ByteArrayOutputStream();
				DataOutputStream dataOut = new DataOutputStream(out);
				dataOut.writeByte(14);
				dataOut.writeByte(2);
				dataOut.writeInt(1);
				sndbyte = out.toByteArray();
				out.close();
				dataOut.close();
			} catch (Exception uee) {
				uee.printStackTrace();
			}
		}
	}

	public Tribes2Ping() {
		if (sndbyte == null) {
			try {
				ByteArrayOutputStream out = new ByteArrayOutputStream();
				DataOutputStream dataOut = new DataOutputStream(out);
				dataOut.writeByte(14);
				dataOut.writeByte(2);
				dataOut.writeInt(1);
				sndbyte = out.toByteArray();
				out.close();
				dataOut.close();
			} catch (Exception uee) {
				uee.printStackTrace();
			}
		}
	}

	public void fill() throws Exception {

		try {
			inet_address = InetAddress.getByName(super.getServerElement().getIp());
			//System.out.println(inet_address.toString()+ "  " + super.getServerElement().getPort().intValue());
			socket = new DatagramSocket();
			snd_packet = new DatagramPacket(sndbyte, sndbyte.length, inet_address, super.getServerElement().getPort().intValue());
			get_packet = new DatagramPacket(getbyte, getbyte.length);
			socket.send(snd_packet);
			long past = System.currentTimeMillis();
			socket.setSoTimeout(1000);
			socket.receive(get_packet);
			System.out.println(new String(getbyte));
			long now = System.currentTimeMillis();
			socket.close();
			super.getServerElement().setPing((int) (now - past));
		} catch (Exception e) {
			socket.close();
			throw e;
		}
	}
}
