/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package searchtool.tribes2.wrappers;

import searchtool.wrappers.*;
import java.io.*;

/**
 * @author thorsten
 *
 */
public class Tribes2Settings extends SearchtoolSettings{
	
	public static final String REGION_MASK = "REGION_MASK";
	
	public Tribes2Settings(File settingsfile){
		super(settingsfile);
	}
	
	protected void initValues() {
		super.initValues();
		setValue(MASTERSERVER_IP, "tribes2.m2.sierra.com");
		setValue(MASTERSERVER_PORT, "28002");
		setValue(CONNECT_COMMAND, "(sample)  /path/to/tribes2.exe <optional parameters here>");
		setValue(SEARCHSTRING, "MpdWa-Wolpers");
		setValue(GAME_DIR, "/path/to/tribes2");
		setValue(MASTERLEVEL_FILTER, "0");
		setValue(FILTERED_MOD, "NONE");
		setValue(FILTERED_MAP, "NONE");
		setValue(SHUTDOWN_TIMEOUT, "0");
		setValue(SELECTED_COLUMN, "2");
		setValue(REGION_MASK, "0xFFFFFFFF");
	}

}
