/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package searchtool.unreal_tournament.protocol;

import searchtool.gamespy.*;
import searchtool.wrappers.*;

/**
 * @author thorsten
 *
 */
public class UnrealTournamentDetails extends GamespyDetails {
	
	public void fill() throws Exception{
		super.fill();
		
		// now set mod depending on mapname.  this is important to make 
		// the searchtool mod/mapfilter work.
		
		ServerElement element = super.getServerElement();
		if ( element != null ){
			String mod = element.getMap().substring( 0 , element.getMap().indexOf("-") );
			element.setMod( mod );
		}
	}

}
