/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package searchtool.unreal_tournament.protocol;

import searchtool.*;
import searchtool.interfaces.*;
import searchtool.protocol.*;
import searchtool.gamespy.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.text.*;
import searchtool.wrappers.*;
import searchtool.util.*;

// thirdparty
import gnu.trove.*;

/**
 * @author thorsten
 *
 */
public class UnrealTournamentRules extends GamespyRules {
	
	
	protected void storeRules(THashMap rulesMap){
		super.storeRules(rulesMap);
		if ( rulesMap.containsKey("password") ){
			String passwd = (String)rulesMap.get("password");
			// plain ut uses True/False, ut2k3 uses 1/0
			if ( passwd.equals("True")  || passwd.equals("1") )
				super.getServerElement().setPassword(ServerElement.PASSWD_REQUIRED);
			else
				super.getServerElement().setPassword(ServerElement.NO_PASSWD);
		}
	}
}
