/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package searchtool.ut2003.protocol;

import java.io.*;
import java.net.*;
import java.util.*;

import searchtool.components.*;
import searchtool.wrappers.*;
import searchtool.ut2003.wrappers.*;
import searchtool.protocol.*;
import searchtool.util.*;
// thirdparty
import gnu.trove.*;

/**
 * @author thorsten
 *
 */
public class Ut2003ServerRequest extends ServerRequest {

	private static String request = null;
	private static byte[] requestBytes = null;
	boolean sessionIncomplete = true;

	public Ut2003ServerRequest(Ut2003Settings settings) {
		super(settings);
	}

	public boolean hasNext() {
		return sessionIncomplete;
	}
	public ServerElement[] getNext(boolean masterlevelFilter) throws Exception {

		// prepare

		super.clearTempServerlist();

		// receive data

		URL url = new URL(super.masterIp +  ((Ut2003Settings) super.settings).getValue(Ut2003Settings.MASTERSERVER_HTML_PAGE));
		URLConnection connection = url.openConnection();
		InputStream inputStream = connection.getInputStream();
		DataInputStream dataIn = new DataInputStream(inputStream);
		TIntArrayList byteList = new TIntArrayList();
		int read;
		try {
			do {
				read = dataIn.readUnsignedByte();
				byteList.add(read);
			} while (true);
		} catch (EOFException ignored) {
		}
		int[] nativeIntArray = byteList.toNativeArray();
		byte[] nativeByteArray = new byte[nativeIntArray.length];
		for (int i = 0; i < nativeByteArray.length; i++)
			nativeByteArray[i] = (byte) nativeIntArray[i];
		String dataString = new String(nativeByteArray);

		// cleanup receive

		inputStream.close();
		dataIn.close();

		// parse data

		StringTokenizer tokenizer = new StringTokenizer(dataString);
		String ip, gamePort, queryPort;
		while (tokenizer.hasMoreTokens()) {
			ip = tokenizer.nextToken();
			gamePort = tokenizer.nextToken();
			queryPort = tokenizer.nextToken();
			ServerElement element = new ServerElement(new IpWrapper(ip, Integer.parseInt(queryPort)));
			element.setGamePort(Integer.parseInt(gamePort));
			super.storeServerAddress(element);
		}

		sessionIncomplete = false;
		return super.getStoredServerElements();

	}

	public void cleanUp() {
		sessionIncomplete = true;
	}

}
