/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package searchtool.ut2003.wrappers;

import searchtool.unreal_tournament.wrappers.UnrealTournamentSettings;
import searchtool.wrappers.*;
import java.io.*;

/**
 * @author thorsten
 *
 */
public class Ut2003Settings extends UnrealTournamentSettings {

	public static String MASTERSERVER_HTML_PAGE = "MASTER_HTML_PAGE";

	public Ut2003Settings(File settingsfile) {
		super(settingsfile);
		initValues();
	}

	protected void initValues() {
		super.initValues();
		setValue(MASTERSERVER_IP, "http://ut2003master.epicgames.com");
		setValue(MASTERSERVER_PORT, "80");
		setValue(CONNECT_COMMAND, "(sample)  /path/to/ut2003.exe <optional parameters here>");
		setValue(SEARCHSTRING, "MpdWa-Wolpers");
		setValue(GAME_DIR, "/path/to/ut2003");
		setValue(MASTERLEVEL_FILTER, "0");
		setValue(FILTERED_MOD, "NONE");
		setValue(FILTERED_MAP, "NONE");
		setValue(SHUTDOWN_TIMEOUT, "0");
		setValue(SELECTED_COLUMN, "2");
		setValue(MASTERSERVER_HTML_PAGE, "/serverlist/full-all.txt");
	}

	public String getConnectPostfix(ServerElement connectToMe) {
		// maybe get password
		String connectPostfix = "";
		//if( connectToMe.getPassword().intValue() == ServerElement.PASSWD_REQUIRED.intValue() ){
		//		connectPostfix +=( " +password \""+ new SearchtoolDialogs.PasswordDialog().showPasswordDialog() + "\" " );
		//}
		connectPostfix += (" unreal://" + connectToMe.getIp() + ":" + connectToMe.getGamePort());
		return connectPostfix;
	}
}
