/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
    
package searchtool.util;

import searchtool.*;
import searchtool.halflife.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import java.net.*;
import java.util.*;

/**

 */

public class IconLib{
    
    private static final ImageIcon[] icons = new ImageIcon[36];
    public static final int PING=0,
    GET_SERVERLIST=1,
    SEARCH_PLAYERS=2,
    EDIT_SETTINGS=3,
    VIEW_FAVOURITES=4,
    VIEW_OUTSIDERS=5,
    QUIT=6,SORT=7,
    MAKE_FAVOURITE=8,
    MAKE_OUTSIDER=9,
    HIGHLIGHT_FAVOURITES=10,
    CONNECT=11,
    DISPLAY_DETAILS=12,
    LOCAL_FILTER=13,
    CLOSE=14,
    HELP=15,
    FIND_SERVER=16,
    ADD_SERVER=17,
    MAKE_FAVOURITE_16X16=18,
    MAKE_OUTSIDER_16X16=19,
    CONNECT_16X16=20,
    DISPLAY_DETAILS_16X16=21,
    SECURE=22,
    REDBALL=23,
    GREENBALL=24,
    CYANBALL=25,
    BLUEBALL=26,
    GREENKEY=27,
    REDKEY=28,
    TEALBALL=29,
    ORANGEBALL=30,
    MASTERSERVER_FILTER=31,
    FILTER=32,
    ARROW_UP=33,
    ARROW_DOWN=34,
    LOGO=35;
    
    
    static{
        
        // icons (not all in use)
        
        //ping
        icons[PING] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/ping.gif"));
        //get serverlist
        icons[GET_SERVERLIST] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/toolbarButtonGraphics/general/Import24.gif"));
        //search players
        icons[SEARCH_PLAYERS] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/find.gif"));
        //edit settings
        icons[EDIT_SETTINGS] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/toolbarButtonGraphics/general/Preferences24.gif"));
        //view favourites
        icons[VIEW_FAVOURITES] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/hitlist.gif"));
        //view outsiders
        icons[VIEW_OUTSIDERS] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/blacklist.gif"));
        //quit
        icons[QUIT] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/quit24.gif"));
        //sort
        icons[SORT] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/sort.gif"));
        //make outsider
        icons[MAKE_OUTSIDER] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/blacklist.gif"));
        //make favourite
        icons[MAKE_FAVOURITE] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/hitlist.gif"));
        //highlight favourites
        icons[HIGHLIGHT_FAVOURITES] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/highlight.gif"));
        //connect to server
        icons[CONNECT] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/connect.gif"));
        //display details
        icons[DISPLAY_DETAILS] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/toolbarButtonGraphics/general/Information24.gif"));
        //local filter
        icons[LOCAL_FILTER] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/kaffeefilter_l.gif"));
        // close tab
        icons[CLOSE] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/exit.gif"));
        // display help window
        icons[HELP] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/help24.gif"));
        // find server
        icons[FIND_SERVER] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/toolbarButtonGraphics/general/Find24.gif"));
        // add server
        icons[ADD_SERVER] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/toolbarButtonGraphics/general/Edit24.gif"));
        // display help window
        icons[MAKE_FAVOURITE_16X16] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/hitlist_16.gif"));
        // display help window
        icons[MAKE_OUTSIDER_16X16] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/blacklist_16.gif"));
        //display details
        icons[DISPLAY_DETAILS_16X16] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/toolbarButtonGraphics/general/Information16.gif"));
        //connect to server
        icons[CONNECT_16X16] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/connect_16.gif"));
        // masterserver filter
        icons[MASTERSERVER_FILTER] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/kaffeefilter_m.gif"));
         // plain filter
        icons[FILTER] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/kaffeefilter.gif"));
         // splashscreen logo
        icons[LOGO] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/logo.png"));
        
        //icons for table
        icons[SECURE] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/attention.gif"));             
        icons[REDBALL] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/redball.gif"));
        icons[GREENBALL] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/greenball.gif"));
        icons[ORANGEBALL] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/orangeball.gif"));
        icons[BLUEBALL] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/blueball.gif"));
        icons[CYANBALL] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/cyanball.gif"));
        icons[TEALBALL] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/tealball.gif"));
        icons[REDKEY] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/redkey.gif"));
        icons[GREENKEY] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/greenkey.gif"));
        icons[ARROW_UP] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/uparrow.gif"));
        icons[ARROW_DOWN] = new ImageIcon(ClassLoader.getSystemResource("searchtool/files/graphics/notsun/downarrow.gif"));
    }
    public static ImageIcon getRedballIcon(){
        return icons[REDBALL];
    }
    public static ImageIcon getGreenballIcon(){
        return icons[GREENBALL];
    }
    public static ImageIcon getOrangeballIcon(){
        return icons[ORANGEBALL];
    }
    public static ImageIcon getBlueballIcon(){
        return icons[BLUEBALL];
    }
    public static ImageIcon getCyanballIcon(){
        return icons[CYANBALL];
    }
    public static ImageIcon getTealballIcon(){
        return icons[TEALBALL];
    }
    public static ImageIcon getRedkeyIcon(){
        return icons[REDKEY];
    }
    public static ImageIcon getGreenkeyIcon(){
        return icons[GREENKEY];
    }
    public static ImageIcon getSecureIcon(){
        return icons[SECURE];
    }
    public static ImageIcon getPingIcon(){
        return icons[PING];   
    }
    public static ImageIcon getGetServerlistIcon(){
        return icons[GET_SERVERLIST];   
    }
    public static ImageIcon getSearchPlayersIcon(){
        return icons[SEARCH_PLAYERS];   
    }
    public static ImageIcon getFindServerIcon(){
        return icons[FIND_SERVER];   
    }
    public static ImageIcon getEditSettingsIcon(){
        return icons[EDIT_SETTINGS];   
    }
    public static ImageIcon getViewFavouritesIcon(){
        return icons[VIEW_FAVOURITES];   
    }
    public static ImageIcon getViewOutsidersIcon(){
        return icons[VIEW_OUTSIDERS];   
    }
    public static ImageIcon getQuitIcon(){
        return icons[QUIT];   
    }
    public static ImageIcon getSortIcon(){
        return icons[SORT];   
    }
    public static ImageIcon getMakeFavouriteIcon(){
        return icons[MAKE_FAVOURITE];   
    }
    public static ImageIcon getMakeOutsiderIcon(){
        return icons[MAKE_OUTSIDER];   
    }
    /*
    public static ImageIcon getHighlightFavouritesIcon(){
        return icons[HIGHLIGHT_FAVOURITES];   
    }
     */
    public static ImageIcon getConnectIcon(){
        return icons[CONNECT];   
    }
    public static ImageIcon getLocalFilterIcon(){
        return icons[LOCAL_FILTER];   
    }
    public static ImageIcon getMasterserverFilterIcon(){
        return icons[MASTERSERVER_FILTER];
    }
    public static ImageIcon getDisplayDetailsIcon(){
        return icons[DISPLAY_DETAILS];   
    }
    public static ImageIcon getCloseIcon(){
        return icons[CLOSE];   
    }
    public static ImageIcon getHelpIcon(){
        return icons[HELP];   
    }
    public static ImageIcon getAddServerIcon(){
        return icons[ADD_SERVER];   
    }
    public static ImageIcon getMakeFavouriteIconSmall(){
        return icons[MAKE_FAVOURITE_16X16];
    }
    public static ImageIcon getMakeOutsiderIconSmall(){
        return icons[MAKE_OUTSIDER_16X16];
    }
    public static ImageIcon getGetDetailsIconSmall(){
        return icons[DISPLAY_DETAILS_16X16];
    }
    public static ImageIcon getConnectIconSmall(){
        return icons[CONNECT_16X16];
    }
    public static ImageIcon getFilterIcon(){
    	return icons[FILTER];
    }
    public static ImageIcon getUpArrowIcon(){
    	return icons[ARROW_UP];	
    }
    public static ImageIcon getDownArrowIcon(){
    	return icons[ARROW_DOWN];	
    }
    public static ImageIcon getLogoIcon(){
    	return icons[LOGO];	
    }
}
