/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package searchtool.util;

import java.io.*;
import java.net.*;
import java.util.*;

import searchtool.components.*;
import searchtool.wrappers.*;
import searchtool.protocol.*;

/**
 * @author thorsten
 * 
 *  this class creates a socket and wraps it into a thread.  this way it will not block a thread
 *  in case there is a connect problem.
 *
 */
public class NonBlockingConnectSocket extends Thread {

	private Socket socket = null;
	private String inetAddress = null;
	private int port = -1;

	public NonBlockingConnectSocket(String inetAddress, int port) {
		this.inetAddress = inetAddress;
		this.port = port;
	}

	public Socket getSocket() {
		return socket;
	}

	public void run() {
		try {
			//System.out.println(inetAddress.toString() + ":" + port);
			socket = new Socket(inetAddress, port);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}

