/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package searchtool.wrappers;

import java.util.*;

/**
 * @author thorsten
 *
 */
public class IpWrapper {

	public final int ip1, ip2, ip3, ip4, port;
	public final long id;

	public IpWrapper(int ip1, int ip2, int ip3, int ip4, int port) {
		this.ip1 = ip1;
		this.ip2 = ip2;
		this.ip3 = ip3;
		this.ip4 = ip4;
		this.port = port;
		this.id = (((long)ip1) << 56) | (((long)ip2) << 48) | (((long)ip3) << 40) | (((long)ip4) << 32) | ((port));
	}
	
	public IpWrapper(String ip, int port) throws Exception {
		StringTokenizer tokenizer = new StringTokenizer(ip,".");
		this.ip1 = Integer.parseInt(tokenizer.nextToken());
		this.ip2 = Integer.parseInt(tokenizer.nextToken());
		this.ip3 = Integer.parseInt(tokenizer.nextToken());
		this.ip4 = Integer.parseInt(tokenizer.nextToken());
		this.port = port;
		this.id = (((long)ip1) << 56) | (((long)ip2) << 48) | (((long)ip3) << 40) | (((long)ip4) << 32) | ((port));
	}
	
	public String toString(){
		return ip1+"."+ip2+"."+ip3+"."+ip4+":"+port;
	}

	public int compareTo(Object O) {
		IpWrapper o = (IpWrapper) O;
		if (ip1 != o.ip1)
			return ip1 - o.ip1;
		if (ip2 != o.ip2)
			return ip2 - o.ip2;
		if (ip3 != o.ip3)
			return ip3 - o.ip3;
		if (ip4 != o.ip4)
			return ip4 - o.ip4;
		if (port != o.port)
			return port - o.port;
		else
			return 0;
	}
}
