/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
    
/*
 * RulesTableSettings.java
 *
 * Created on March 18, 2002, 3:57 PM
 */

package searchtool.wrappers;

import java.io.*;
import java.util.*;
import searchtool.*;
import searchtool.util.*;

/**
 * this class stores the selected rules of the table
 * placed on the details dialog.
 * 
 * @author  zoidberg
 * @version 
 */
public class RulesTableSettings extends XMLStorable{
    
    private Vector rulesToRemember = new Vector();
    
    /** Creates new RulesTableSettings */
    public RulesTableSettings(File configFile) {
    	super(configFile);
    	super.load();
         String[] rules = super.getAllKeys();
         for(int i = 0; i < rules.length; i++)
         	rulesToRemember.add(rules[i]); 
    }
    
    public Vector getRules(){
        return rulesToRemember;
    }
    
    public void addRule(String rule){
        rulesToRemember.add(rule);
        super.setValue(rule,"dummy");
    }
    
    public void removeRule(String rule){
        for(int i = 0; i < rulesToRemember.size(); i++){
            if(rule.equals((String)rulesToRemember.get(i))){
                rulesToRemember.remove(i);
                break;
            }
        }
        super.removeKey(rule);
    }   
    
    public boolean containsRule(String rule){
        for(int i = 0; i < rulesToRemember.size(); i++){
            if(rule.equals((String)rulesToRemember.get(i))){
                return true;
            }
        }
        return false;
    }
}
